/**
 * Rule.java
 *
 * File generated from the XValidator4::Rule uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.model;

import junit.framework.Assert;
import junit.framework.AssertionFailedError;
import net.ihe.gazelle.hql.FilterLabel;
import net.ihe.gazelle.xvalidation.core.exception.GazelleXValidationException;
import net.ihe.gazelle.xvalidation.core.report.Aborted;
import net.ihe.gazelle.xvalidation.core.report.Notification;
import org.hibernate.annotations.Type;
import org.jboss.seam.security.Identity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.w3c.dom.Node;

import javax.persistence.CascadeType;
import javax.persistence.CollectionTable;
import javax.persistence.Column;
import javax.persistence.ElementCollection;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.Lob;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.PostLoad;
import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Transient;
import javax.persistence.UniqueConstraint;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import java.util.ArrayList;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.Map;

// End of user code

/**
 * Description of the class Rule.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Rule", propOrder = { "assertions", "expression", "appliesTo", "description", "keyword",
		"lastModified", "lastModifier", "level", "status", "version" })
@XmlRootElement(name = "Rule")
@Entity
@Table(name = "xval_rule", schema = "public", uniqueConstraints = @UniqueConstraint(columnNames = { "version",
		"keyword" }))
@SequenceGenerator(name = "xval_rule_sequence", sequenceName = "xval_rule_id_seq", allocationSize = 1)
public class Rule implements java.io.Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	private static Logger log = LoggerFactory.getLogger(Rule.class);
	public static final String COPY_SUFFIX = "_COPY";
	
	@Id
	@GeneratedValue(generator = "xval_rule_sequence", strategy = GenerationType.SEQUENCE)
	@Column(name = "id", nullable = false, unique = true)
	@XmlTransient
	private Integer id;

	/**
	 * for requirement coverage.
	 */
	@XmlElement(name = "Assertion")
	@ManyToMany(cascade = { CascadeType.ALL }, mappedBy = "rules", targetEntity = Assertion.class)
	private List<Assertion> assertions;

	@XmlElement(name = "Expression", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "expression_id")
	@NotNull
	private Expression expression;

	/**
	 * For a comprehensive display of the expression by the user
	 */
	@XmlTransient
	@Column(name = "textual_expression")
	@Type(type = "text")
	@Lob
	private String textualExpression;

	/**
	 * Displayed to the user in the final report.
	 */
	@XmlAttribute(name = "description", required = true)
	@Lob
	@Type(type = "text")
	@NotNull
	private String description;

	@XmlAttribute(name = "keyword", required = true)
	@NotNull
	private String keyword;

	@XmlAttribute(name = "lastModified", required = true)
	@XmlSchemaType(name = "dateTime")
	@Transient
	private javax.xml.datatype.XMLGregorianCalendar lastModified;

	@XmlAttribute(name = "lastModifier", required = true)
	@Column(name = "last_modifier", nullable = false)
	private String lastModifier;

	@XmlTransient
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "last_modified_date")
	private Date lastModifiedDate;

	@XmlAttribute(name = "level", required = true)
	@NotNull
	private Level level;

	@XmlAttribute(name = "status", required = true)
	@NotNull
	private RuleStatus status;

	@XmlAttribute(name = "version", required = true)
	@NotNull
	private String version;

	/**
	 * If not null, restrain the application of the rule to a subset of inputs
	 */
	@XmlElement(name = "AppliesTo")
	@Column(name = "applies_to")
/*	@ElementCollection(targetClass = String.class)
	@CollectionTable(name = "xval_rule_appliesTo", joinColumns = @JoinColumn(name = "input_file_keyword"))*/
	private ArrayList<String> appliesTo;

	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	@Transient
	private org.w3c.dom.Node xmlNodePresentation;

	@XmlTransient
	@ManyToOne(targetEntity = GazelleCrossValidatorType.class)
	@JoinColumn(name = "gazelle_x_validator_id")
	private GazelleCrossValidatorType gazelleCrossValidator;

	public Rule(GazelleCrossValidatorType validator) {
		super();
		this.gazelleCrossValidator = validator;
		this.status = RuleStatus.INACTIVE;
		this.expression = new Expression();
	}

	public Rule() {
		super();
	}

	public Rule(Rule rule) {
		super();
		this.gazelleCrossValidator = rule.getGazelleCrossValidator();
		this.status = RuleStatus.INACTIVE;
		this.keyword = rule.getKeyword() + COPY_SUFFIX;
		this.description = rule.getDescription();
		this.level = rule.getLevel();
		for (Assertion assertion: rule.getAssertions()){
			Assertion newAssertion = new Assertion(assertion);
			newAssertion.addRule(this);
			addAssertion(newAssertion);
		}
		this.appliesTo = new ArrayList<String>(rule.getAppliesTo());
		this.expression = new Expression(rule.getExpression());
		this.textualExpression = rule.getTextualExpression();
		this.version = COPY_SUFFIX;
	}

	@PreUpdate
	@PrePersist
	public void onUpdate() {
		this.lastModifiedDate = new Date();
		if (Identity.instance().isLoggedIn()) {
			this.lastModifier = Identity.instance().getCredentials().getUsername();
		}
	}

	/**
	 * Return assertion.
	 * 
	 * @return assertion : for requirement coveragefor requirement coverage
	 */
	public List<Assertion> getAssertions() {
		if (assertions == null) {
			assertions = new ArrayList<Assertion>();
		}
		return assertions;
	}

	/**
	 * Set a value to attribute assertion.
	 * 
	 * @param assertion
	 *            : for requirement coveragefor requirement coverage.
	 */
	public void setAssertions(List<Assertion> assertion) {
		this.assertions = assertion;
	}

	/**
	 * Add a assertion to the assertion collection.
	 * 
	 * @param assertionElement
	 *            Element to add.
	 */
	public void addAssertion(Assertion assertionElement) {
		this.getAssertions().add(assertionElement);
	}

	/**
	 * Remove a assertion to the assertion collection.
	 * 
	 * @param assertionElement
	 *            Element to remove
	 */
	public void removeAssertion(Assertion assertionElement) {
		this.getAssertions().remove(assertionElement);
	}

	/**
	 * Return expression.
	 * 
	 * @return expression
	 */
	public Expression getExpression() {
		return expression;
	}

	/**
	 * Set a value to attribute expression.
	 * 
	 * @param expression
	 *            .
	 */
	public void setExpression(Expression expression) {
		this.expression = expression;
	}

	/**
	 * Return description.
	 * 
	 * @return description : Displayed to the user in the final reportDisplayed to the user in the final report
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * Set a value to attribute description.
	 * 
	 * @param description
	 *            : Displayed to the user in the final reportDisplayed to the user in the final report.
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * Return keyword.
	 * 
	 * @return keyword
	 */
	@FilterLabel
	public String getKeyword() {
		return keyword;
	}

	/**
	 * Set a value to attribute keyword.
	 * 
	 * @param keyword
	 *            .
	 */
	public void setKeyword(String keyword) {
		this.keyword = keyword;
	}

	/**
	 * Return lastModifiedDate.
	 * 
	 * @return lastModifiedDate
	 */
	
	public javax.xml.datatype.XMLGregorianCalendar getLastModified() {
		return lastModified;
	}
	
	@PostLoad
	public void setLastModified() {
		if (this.lastModifiedDate != null) {
			GregorianCalendar calendar = new GregorianCalendar();
			calendar.setTime(this.lastModifiedDate);
			try {
				this.lastModified = DatatypeFactory.newInstance().newXMLGregorianCalendar(calendar);
			} catch (DatatypeConfigurationException e) {
				log.error(e.getMessage(), e);
			}
		} else {
			this.lastModified = null;
		}
	}

	/**
	 * Set a value to attribute lastModifiedDate.
	 * 
	 * @param lastModifiedDate
	 *            .
	 */
	public void setLastModified(javax.xml.datatype.XMLGregorianCalendar lastModifiedDate) {
		this.lastModified = lastModifiedDate;
		setLastModifiedDate(this.lastModified.toGregorianCalendar().getTime());
	}

	public void setLastModifiedDate(javax.xml.datatype.XMLGregorianCalendar lastModified) {
		if (lastModified != null) {
			setLastModifiedDate(lastModified.toGregorianCalendar().getTime());
		}
		this.lastModified = lastModified;
	}

	/**
	 * Return lastModifier.
	 * 
	 * @return lastModifier
	 */
	public String getLastModifier() {
		return lastModifier;
	}

	/**
	 * Set a value to attribute lastModifier.
	 * 
	 * @param lastModifier
	 *            .
	 */
	public void setLastModifier(String lastModifier) {
		this.lastModifier = lastModifier;
	}

	/**
	 * Return level.
	 * 
	 * @return level
	 */
	public Level getLevel() {
		return level;
	}

	/**
	 * Set a value to attribute level.
	 * 
	 * @param level
	 *            .
	 */
	public void setLevel(Level level) {
		this.level = level;
	}

	/**
	 * Return status.
	 * 
	 * @return status
	 */
	public RuleStatus getStatus() {
		return status;
	}

	/**
	 * Set a value to attribute status.
	 * 
	 * @param status
	 *            .
	 */
	public void setStatus(RuleStatus status) {
		this.status = status;
	}

	/**
	 * Return version.
	 * 
	 * @return version
	 */
	public String getVersion() {
		return version;
	}

	/**
	 * Set a value to attribute version.
	 * 
	 * @param version
	 *            .
	 */
	public void setVersion(String version) {
		this.version = version;
	}

	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "Rule", this);
		}
		return xmlNodePresentation;
	}

	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

	public Date getLastModifiedDate() {
		return lastModifiedDate;
	}

	public void setLastModifiedDate(Date lastModifiedDate) {
		this.lastModifiedDate = lastModifiedDate;
	}

	public String getTextualExpression() {
		if (textualExpression == null && this.expression != null && this.expression.getExpression() != null) {
			this.textualExpression = this.expression.getExpression().toString();
		}
		return textualExpression;
	}

	public void setTextualExpression(String textualExpression) {
		this.textualExpression = textualExpression;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public GazelleCrossValidatorType getGazelleCrossValidator() {
		return gazelleCrossValidator;
	}

	public void setGazelleCrossValidator(GazelleCrossValidatorType gazelleCrossValidator) {
		this.gazelleCrossValidator = gazelleCrossValidator;
	}

	public boolean isActive() {
		return status.equals(RuleStatus.ACTIVE);
	}

	public boolean isInactive() {
		return status.equals(RuleStatus.INACTIVE);
	}

	public boolean isDeprecated() {
		return status.equals(RuleStatus.DEPRECATED);
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = (prime * result) + ((keyword == null) ? 0 : keyword.hashCode());
		result = (prime * result) + ((version == null) ? 0 : version.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		Rule other = (Rule) obj;
		if (keyword == null) {
			if (other.keyword != null) {
				return false;
			}
		} else if (!keyword.equals(other.keyword)) {
			return false;
		}
		if (version == null) {
			if (other.version != null) {
				return false;
			}
		} else if (!version.equals(other.version)) {
			return false;
		}
		return true;
	}

	public Notification evaluate(Map<String, Node> nodes, ValidatorConfiguration configuration){
		if (expression != null) {
			Notification expressionNotification =  expression.evaluate(nodes, configuration, getLevel());
			return fillNotification(expressionNotification);
		} else {
			Aborted notification = new Aborted();
			notification.setReason("This rule does not contain any expression");
			return fillNotification(notification);
		}
	}

	private Notification fillNotification(Notification notification){
		notification.setTest(getKeyword());
		notification.setDescription(getDescription());
		notification.getAssertion().addAll(getAssertions());
		notification.setExpression(getTextualExpressionForReport());
		for (String keyword : getAppliesTo()) {
			notification.addProcessedInput(keyword);
		}
		return notification;
	}

	public ArrayList<String> getAppliesTo() {
		if (appliesTo == null) {
			appliesTo = new ArrayList<String>();
		}
		return appliesTo;
	}

	public void setAppliesTo(ArrayList<String> appliesTo) {
		this.appliesTo = appliesTo;
	}

	public void addAppliesTo(String inputKeyword) {
		getAppliesTo().add(inputKeyword);
	}

	public void removeAppliesTo(String inputKeyword) {
		getAppliesTo().remove(inputKeyword);
	}

	public void testExpressionIsCorrect() throws AssertionFailedError {
		Assert.assertNotNull("No expression has been defined for this rule", expression);
		expression.testCorrectness();
		setAppliesTo(expression.appliesTo());
	}

	public ValidatorConfiguration getValidatorConfiguration() {
		if (gazelleCrossValidator != null) {
			return gazelleCrossValidator.getConfiguration();
		} else {
			return null;
		}
	}

	public AbstractExpression copyExpression() {
		if (this.expression != null) {
			return expression.createCopy();
		} else {
			return null;
		}
	}

	public boolean isValidatorUnderDevelopment() {
		return gazelleCrossValidator.isUnderDevelopment();
	}

	public boolean isValidatorUnderMaintenance() {
		return gazelleCrossValidator.isUnderMaintenance();
	}

	public String getTextualExpressionForReport() {
		String exp = getTextualExpression();
		if (exp != null){
			return exp.replace("<br/>", "\n");
		} else {
			return null;
		}
	}

	public boolean isCopy(){
		return (keyword != null && keyword.contains(COPY_SUFFIX));
	}
}